QGIS Application - Bug report #7540
Merge tool bug when a shapefile is loaded multiple times
2013-04-07 07:33 PM - Olivier Dalang

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Digitising

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corruptsdata: Copied to github as #: 16483
Description

Hi !

When a Shapefile is loaded multiple times (either in the same project via "duplicate layer" or in two different QGis instances), there is a
critical bug upon merging features.

Both merged parts simply disappear without any error (though it seems sometimes QGis crashes).
To reproduce:

. create a new shapefile (line or polygon)

. enter edit mode

. draw a feature and split it several times with the scissor tool

. exit edit mode

. duplicate the layer

. enter edit mode on one of the two layers

. select two line segments and merge them with the merge tool
. exit edit mode

. reload the project and see!!
Related issues:
Related to QGIS Application - Bug report # 8822: OGR: Repack in running session Closed 2013-10-11

Associated revisions

Revision 78b04df9 - 2013-07-09 04:25 PM - Jiirgen Fischer

ogr provider: reopen the data source if a REPACK failed (fixes #7540)

Revision 7d7cdcd3 - 2015-05-28 12:34 PM - Matthias Kuhn
Repack shapefiles when saving after deleting features

- QgsVectorDataProvider::dataChanged() will be emitted

- QgsVectorLayer::dataChanged() will be emitted

- Clears QgsVectorLayerCache

- Reloads the attribute table

- Clears the selection

Looking forward to people complaining about their lost selection...

Fix #10560
Fix #11989
Refs #8317
Refs #8822
Refs #10483
Refs #11007
Refs #7540
Refs #11398
Refs #11296

History

#1 - 2013-04-08 02:07 PM - Giovanni Manghi
- Status changed from Open to Feedback

it is a regression since 1.87 I'm not able to replicate the issue here, but maybe I'm doing it wrong.

#2 - 2013-04-08 03:58 PM - Olivier Dalang

Yes it's a regression, the problem does not show up in 1.8...

Here (Windows 7) it seems to happen every time when following those steps.

If confirmed, this should be a blocker, since it leads to data corruption.

#3 - 2013-04-08 03:59 PM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

#4 - 2013-04-22 06:45 AM - Radim Blazek

9) reload the project and see !!

What does it mean "reload the project"? Reopen project file or refresh display?

#5 - 2013-04-22 07:37 AM - Olivier Dalang

Actually, when you refresh display only :
- on the layer that was not edited, you see that the two merged parts have disappeared
- on the layer that was edited, you see the two merged parts plus the result of the merge

But actually, I'm just discovering that the shapefile seems in a deeper mess, even after reloading : if you create a new polygon, no matter what shape, it

will take the shape of the result of the merge.

Here's a screencast of the procedure :
https://www.dropbox.com/s/84nj515s6mfu09f/mergeBug2.avi?m

#6 - 2013-06-02 01:47 AM - Giovanni Manghi
- Status changed from Feedback to Open
https://www.dropbox.com/s/84nj515s6mfu09f/mergeBug2.avi?m

#7 - 2013-06-28 01:10 AM - Giovanni Manghi
- Category set to Digitising

#8 - 2013-07-01 03:53 PM - Salvatore Larosa

is it still true ?

following the above steps | did not get any crash !

tested with a polygon layer and | do not see unusual behavior.

#9 - 2013-07-02 04:01 AM - Giovanni Manghi

following the above steps I did not get any crash !

tested with a polygon layer and | do not see unusual behavior.

| don't think it causes crash, it causes data corruption.

#10 - 2013-07-08 09:43 AM - Jiirgen Fischer
- Status changed from Open to Feedback

Giovanni Manghi wrote:

| don't think it causes crash, it causes data corruption.

So you can reproduce the problem? Just checking, if | should try harder...

#11 - 2013-07-09 12:40 AM - Giovanni Manghi

So you can reproduce the problem? Just checking, if | should try harder...

no | can't.

Olivier still true for you?

#12 - 2013-07-09 01:26 AM - Olivier Dalang

Hi !

The behavior changed a little bit but | still get data corruption (with master from yesterday, under Windows 7).
It's no more necessary to reload the project to see the data loss.

Here's a screencast : https://www.dropbox.com/s/g70fkaus6j40vil/mergeBug4.avi

#13 - 2013-07-09 02:51 AM - Jiirgen Fischer
https://www.dropbox.com/s/g70fkaus6j40vll/mergeBug4.avi

- Status changed from Feedback to Open

ok, | can reproduce it now. | suspect it's a file locking issue in OGR (might be tied to windows). Looking into GDAL now...

#14 - 2013-07-09 03:30 AM - Jiirgen Fischer

- Assignee set to Jirgen Fischer

#15 - 2013-07-09 07:25 AM - Jiirgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"78b04df91a1b85ee70ff5b326980f480b3069d47".

#16 - 2013-07-09 07:28 AM - Jiirgen Fischer

Jurgen Fischer wrote:

Fixed in changeset commit:"78b04df91a1b85ee70ff5b326980f480b3069d47".

It was caused by locking. QGIS does a REPACK after deleting and that silently fails with current OGR. GDAL pull request !#17 should fix this by adding

an error message. reopening the original DBF if it can't be removed and cleaning up the *_packed.dbf.

Nevertheless QGIS now checks if there still is a *_packed.dbf to detect that the REPACK failed and reopens the dataset in that case.

#17 - 2014-10-04 01:48 PM - Giovanni Manghi

- Status changed from Closed to Reopened
- Target version changed from Version 2.0.0 to Version 2.6

Sorry to reopen this, seems master still affected. See also #11082

#18 - 2014-10-21 02:47 AM - Jiirgen Fischer

- Assignee deleted (Jiirgen Fischer)

#19 - 2014-10-24 09:11 AM - Giovanni Manghi

it is pretty easy to replicate this issue, it is just needed to "insist" a bit. Here two screencast, that as some point show that after removing a shape and
re-adding it features are lost!

The second show also a possible bug in the "split features" tool.

https://www.dropbox.com/s/rpjcn8gpn75r31m/t7540 1.mp4?dI=0

https://www.dropbox.com/s/9n9a7j1puugwpnr/t7540 2.mp47?di=0

#20 - 2014-10-24 09:16 AM - Giovanni Manghi
https://github.com/OSGeo/gdal/pull/17
https://www.dropbox.com/s/rpjcn8gpn75r31m/t7540_1.mp4?dl=0
https://www.dropbox.com/s/9n9a7j1puugwpnr/t7540_2.mp4?dl=0

Giovanni Manghi wrote:

Sorry to reopen this, seems master still affected. See also #11082

after all it does not seems related... | have a VM with ggis running against gdal/ogr trunk and | can still see the issue described in this ticket.

#21 - 2014-10-30 07:13 AM - Giovanni Manghi
- Status changed from Reopened to Feedback

it seems this could have been solved by this commit:4cf08c5c112278ab4f50cf21b735a4a58d6a98aa

#22 - 2014-10-31 05:55 AM - Jiirgen Fischer

- Target version changed from Version 2.6 to Future Release - High Priority

#23 - 2014-11-03 02:51 PM - Giovanni Manghi

- Status changed from Feedback to Closed
- Resolution set to fixed/implemented

after commit:4cf08c5c112278ab4f50cf21b735a4a58d6a98aa | really cannot make to replicate this issue. That commit solves also partially #11007 (but

only for the case of edited features, still there is an issue with deleted ones).

Please reopen if necessary.
